#(c)www.stani.be
import blenpy
INFO=blenpy.INFO.copy()

INFO['description']=\
"""Mouse actions"""

__doc__=INFO['doc']%INFO
#_______________________________________________________________________________

import Blender, os
#---general
class Exit:
    def __init__(self):
        self.fun=blenpy.pyGui.current[-1].start
        self.exit=Blender.Draw.Exit
    def __call__(self):
        Blender.Draw.Exit=self.exit
        self.fun()

def load(fileName):
    """Load as Blender Text"""
    blenpy.pyGui.pythonLoad(fileName)

def reference(fileName):
    """Reference (run)"""
    fileName=str(fileName)
    fileBase=os.path.basename(fileName)
    try:
        text=Blender.Text.get(fileBase)
        text.clear()
    except:
        text=Blender.Text.New(fileBase)
    text.write("""#Press Alt+P to run %s

fileName=%s
import sm.scriptutils
sm.scriptutils.run(fileName)"""\
    %(fileBase,repr(fileName)))

try:
    import sm.scriptutils
    def run(fileName):
        """Run"""
        exit=Exit()
        blenpy.pyGui.current[-1].exit(forced=1)
        Blender.Draw.Exit=exit
        sm.scriptutils.run(fileName)
    def importBl(fileName):
        """Import as module"""
        sm.scriptutils.importMod(fileName)
except ImportError,message:
    print "Warning [mouse.py]: 'Run' and 'Import' can not be loaded (%s)"%message


#---pythonWin
if os.sys.platform=='win32':
    try:
        import blenpy.plugins,sm.win
        def blenderPythonWin(fileName=None):
            """Edit with PythonWin Light"""
            import Blender,blenpy.plugins,sm.win,os
            sm.win.PythonWinPreload(\
                fileName=fileName,
                path=os.path.join(os.path.dirname(blenpy.plugins.__file__),
                    'PythonWinFiles.txt'),
                modules='Blender',
                statusText='blenpy - www.stani.be'
            )

        def blenderPythonWinSilver(fileName=None):
            """Edit with PythonWin"""
            sm.win.PythonWinPreload(\
                fileName=fileName,
                path=os.path.join(os.path.dirname(blenpy.plugins.__file__),
                    'PythonWinFiles.txt'),
                browse=[(Blender,'Blender Module - blenpy')],
                modules='Blender',
                statusText='blenpy - www.stani.be',
            )
            pywin.framework.scriptutils()

        def blenderPythonWinGold(fileName=None):
            """Edit with PythonWin >>>"""
            import Blender,blenpy.plugins,sm.win,os
            inspect=blenpy.pyGui.inspect()
            sm.win.PythonWinPreload(\
                fileName=fileName,
                path=os.path.join(os.path.dirname(blenpy.plugins.__file__),
                    'PythonWinFiles.txt'),
                browse=[(inspect,'>>> - blenpy')],
                modules='blenpy.plugins.all',
                statusText='blenpy - www.stani.be'
            )
    except ImportError,message:
        print "Warning [mouse.py]: 'PythonWin' can not be loaded (%s)"%message



#---Import Modules-------------------------------------------------------------
#Must be in end in order to access __doc__
import sm.tk
import blenpy.pyGui

#---Depricated-----------------------------------------------------------------
def _execfileBl(fileName):
    """Run (execfile)"""
    import os,sys
    print "\nexecfile('%s')..."%fileName
    path=os.path.dirname(fileName)
    if path not in sys.path:sys.path.append(path)
    execfile(fileName)

def _importOld(fileName):
    """Import as module"""
    import os,sys
    print "\nimport %s"%fileName
    path=os.path.dirname(fileName)
    if path not in sys.path:sys.path.append(path)
    module=__import__(os.path.splitext(os.path.basename(fileName))[0])
    reload(module)

def _debug(fileName):
    """Debug (not working)

    Unfortunately not working:
    Problem with __nonzero__ attribute of ColorDelegator?

    Anyone interested in fixing this?"""
    try:
        import smBl.tk as tk
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    tk.debugger(fileName,title='Blender Python Debugger - www.stani.be')

