#(c)www.stani.be

#---Choose your editor---------------------------------------------------------
##BOA=["C:\Python22\python.exe","c:\\python22\\lib\\site-packages\\wxpython\\tools\\boa\\boa.py"]
##PYTHONWIN=['C:\\Python22\\Lib\\site-packages\\Pythonwin\\pythonwin.exe']
##EDITOR={'win32':PYTHONWIN}


#---Module information---------------------------------------------------------
import blenpy
INFO=blenpy.INFO.copy()
INFO['description']=\
"""This module (pyGui) provides a graphical user interface for Python in Blender.

Usage (within Blender Text window):
>>> from blenpy.pyGui import PythonGui
>>> PythonGui()"""

__doc__=INFO['doc']%INFO

##__instructions__=\
##"""Add/Remove paths to the menu:#@color=self.headColor#@bgColor=self.headBg
##-if wxPython is installed,use 'b'
##  to ADD a directory to the menu.
##-otherwise,type the directory in the
##  edit field '...' and use '+' to ADD
##  it to the menu.
##-use '-' to REMOVE selected path
##
##Mouse actions for python buttons:#@color=self.headColor#@bgColor=self.headBg
##-left:LOAD the python code with
##  header to remember the filename.
##-middle button:RUN or execfile(file).
##  (import * is not supported within file)
##-right button:EDIT the file (editor path
##  in top of source code of this file)
##
##Other buttons:#@color=self.headColor#@bgColor=self.headBg
##-REVERT ALL:reload all the contents
##  from the saved file.  Usefull if you
##  saved changes in an external editor.
##-SAVE ALL:saves the source code to
##  the file ignoring the Plender header.
##->Remark:These buttons only include
##  files,which are loaded with Plender
##  and of which the headers are intact.
##  To exclude a file,in header:include=0
##-PYCRUST: Launch interactive shell
##  & class browser (www.wxpython.org)
##  Save first,blender may crash!!"""

#---Import modules------------------------------------------------------------=
#standard modules
import pprint,pydoc,os,sys,types
sys.argv=['']

#blender independant modules
from sm.tk import inspector,askdirectory

try:
    from sm.wxp import dirDialog,pyCrust
except AttributeError:
    print 'Blenpy Warning: can not import browse directory dialog or PyCrust from wxPython'
    print 'Probably you do not have the right version of wxPython installed.'

#blender dependant modules
#try:
import Blender,blenpy,gui
#except ImportError:
print "This module must be run within Blender"


#---Constants------------------------------------------------------------------
__file__=gui.__file__
__path__=os.path.dirname(__file__)
ACTIVESTATE_URL='www.ActiveState.com'
FILE="#@"
DEFAULT_SETTINGS=\
    {'extensions': '.py,.pyw,.leo',
     'inspect_depth': 6,
     'launchIndex': 3,
     'mouseLeftIndex': 2,
     'mouseMiddleIndex': 3,
     'mouseRightIndex': 7,
     'path_depth': 5,
     'paths': []}
WORKING_DIR='working path'
##INSTRUCTIONS=__instructions__.split('\n')
##INSTRUCTIONS.reverse()
BUILTIN_TYPES=[getattr(types,t).__name__ for t in dir(types) if type(getattr(types,t))==types.TypeType]
BLENDER_ATTRIBUTES={Blender.Types.ArmatureType:[],
                    Blender.Types.BoneType:[],
                    Blender.Types.bufferType:['list'],
                    Blender.Types.ButtonType:['val'],
                    Blender.Types.CameraType:[],
                    Blender.Types.constantType:[],
                    Blender.Types.CurveType:[],
                    Blender.Types.ImageType:[],
                    Blender.Types.IpoType:[],
                    Blender.Types.LampType:[],
                    Blender.Types.MaterialType:[],
                    Blender.Types.MetaballType:[],
                    Blender.Types.NMColType:['r','g','b','a'],
                    Blender.Types.NMeshType:['name','verts','faces','mats','has_col','has_uvco'],
                    Blender.Types.NMFaceType:['v','col','smooth'],
                    Blender.Types.NMVertType:['index','co','uvco','no'],
                    Blender.Types.ObjectType:[],
                    Blender.Types.rgbTupleType:[],
                    Blender.Types.SceneType:[],
                    Blender.Types.TextType:[],
                    Blender.Types.vectorType:[]}
BLENDER_TYPES=BLENDER_ATTRIBUTES.keys()
BLENDER_EXTRA_ATTRIBUTES=BLENDER_ATTRIBUTES[Blender.Types.NMColType][1:]+\
    BLENDER_ATTRIBUTES[Blender.Types.NMFaceType]+\
    BLENDER_ATTRIBUTES[Blender.Types.NMVertType]+\
    BLENDER_ATTRIBUTES[Blender.Types.NMeshType][1:]
INVENTORY='This drawing contains:\n'
MODULE_ERROR="Error: Module(s) %s required, but not installed (%s)!"
SPACER=5
TEXTCOLOR=(0.3,0.3,0.3)
BLENDERCRUST_WELCOME=\
"""This is a tweaked version of PyCrust (see www.wxpython.org).

NODE TREE:

Left is an expandable node tree, which enables you to explore
all python objects.  The most important objects (materials,
lamps,...) are already provided in the different tabs. The
objects of this session will appear under the 'Namespace tab'
node. Double click on any node to open it in a new window.



SHELL:

Above is an advanced python shell with advanced features, such as
auto-completion. As a quick start following code is automatically executed:


>>> """
SHELL_WELCOME=\
"""import Blender
>>> import %s
>>> Armatures=Blender.Armature.Get()
>>> Cameras=Blender.Camera.Get()
>>> Images=Blender.Image.Get()
>>> Ipos=Blender.Ipo.Get()
>>> Lamps=Blender.Lamp.Get()
>>> Materials=Blender.Material.Get()
>>> Objects=Blender.Object.Get()
>>> Scenes=Blender.Scene.Get()
>>> Texts=Blender.Text.Get()
>>> Worlds=Blender.World.Get()
If you type 'Objects[0]', the first object of the drawing will be returned.
"""%INFO['title']

USER_PATH=os.path.expanduser(os.path.join('~','.blenpy'))
try:
    os.mkdir(USER_PATH)
except:
    pass
#---extEditors---------------------------------------------------------------==
from blenpy.plugins import editors

class Editor:
    """Callable class used for mouse actions 'send to'"""
    def __init__(self,editor):
        """editor is a text line from editors.txt"""
        self.editor=[x.strip() for x in editor]
    def __call__(self,fileName):
        """Edit in external editor"""
        if fileName.find(' ')>-1: fileName='"%s"'%fileName
        params=self.editor[1:]+[fileName]
        os.spawnl(os.P_NOWAIT,self.editor[1],*params)

extEditors={}
def getextEditors():
    global editors,extEditors
    #external editors: send to
    extEditorsFile=open(os.path.join(os.path.dirname(editors.__file__),'editors.txt'))
    extEditorsLines=[line.split('@')[0] for line in extEditorsFile.readlines() if line.strip()]
    extEditorsFile.close()
    #arrange editors by platform & select of current platform
    for line in extEditorsLines:
        split=line.split(',')
        if split[1] not in extEditors.keys():
            extEditors[split[1]]={}
        extEditors[split[1]][split[0]]=Editor([split[0]]+split[2:])
    extEditors=extEditors[sys.platform]
getextEditors()

#---pyShell: launchIdle------------------------------------------------------==
try:
    import PyShell
    launchIdle=PyShell.main
except:
    def launchIdle():
        print MODULE_ERROR%('PyShell',ACTIVESTATE_URL)

#---Inspector dialog: inspectorBlender---------------------------------------==
def inspectType(object):
    """Returns the name of type."""
    t=type(object)
    if t==types.NoneType:name='none'
    elif t == types.BuiltinFunctionType:name='function'
    elif t in [types.BuiltinMethodType,types.MethodType]:name='method'
    else:name= t.__name__
    return name

class DocString:
    """Used by blenderCrust for nicer display of __doc__ (not for Tkinter inspector)"""
    def __init__(self,d):
        self.__doc__=d

def inspectTopic(object,prefix='',recursive=2,useDocString=0):
    """Private recursive helper function for inspect."""
    if recursive:
        objectType=type(object)
        objectTypeName=objectType.__name__
        isBlenderType=objectType in BLENDER_TYPES
        if objectType==types.ListType:
            contents={}
            for o in object:
                contents[str(o)]=inspectTopic(o,recursive=recursive-1,
                                              useDocString=useDocString)
            if not contents:return []
            else: return contents
        elif objectType in [types.InstanceType] or isBlenderType:
            if objectTypeName in ['Vector','NMVert']:
                return tuple(object)
            elif objectTypeName =='Matrix':
                l=[]
                for i in range(4):l.append(object[i])
                return l
            else:
                contents={'__type__':type(object),
                          '__typeName__':type(object).__name__}
                try:
                    contents['.name']=object.name
                except:
                    pass
                try:
                    contents['__class__']=object.__class__
                except:
                    pass
                try:
                    properties=object.properties
                    if type(properties)!=types.ListType:properties=[]
                except:
                    properties=[]
                attributes=dir(object)
                print object,attributes
                for attribute in BLENDER_EXTRA_ATTRIBUTES+properties:
                    if attribute not in attributes:
                        attributes.append(attribute)
                    #bug in Blender2.28
                    if 'filename' in attributes:
                        attributes.remove('filename')
                for attribute in attributes:
                    print object,attribute
                    if attribute=='ipo':
                        tName='none  '
                        inspectObj='ipo member access deprecated,use self.getIpo() instead!'
                    elif attribute!='starColNoise':#error in Blender226
                        try:
                            attrObj=getattr(object,attribute)
                            print '   ',attrObj
                            if attribute=='__doc__':
                                tName=''
                                if useDocString:inspectObj=DocString(attrObj)
                                else:inspectObj=attrObj
                            else:
                                tName=inspectType(attrObj)+'  '
                                inspectObj=inspectTopic(attrObj,
                                    prefix=prefix+attribute+'.',
                                    recursive=recursive-1,
                                    useDocString=useDocString)
                            contents[tName+'  '+attribute]=inspectObj
                            valid=1
                        except:
                            valid=0
                    a=attribute.lower()
                    blender228bugs=['getfilename','getinversematrix','getmatrix','gettracked']
                    if valid and ((a[:3]=='get' and (a not in ['getselected']+blender228bugs)) or a=='aslines'):
                        try:
                            print a
                            called=getattr(object,attribute)()
                            print 'ok',called
                            contents['>>> '+attribute+'()']=inspectTopic(called,
                                prefix=prefix+attribute+'.',
                                recursive=recursive-1,useDocString=useDocString)
                        except:
                            pass
                return contents
        else:return object
    else: return object

def inspect(objects={},recursive=10,useDocString=1):
    """Returns a dictionary which contains all available Python information."""
    try:
        BlenderMeshGet=inspectTopic(Blender.Mesh.Get(),recursive=recursive)
    except:
        BlenderMeshGet='Not yet supported.'
    objects['Blender']=Blender
    print 'Blender'
    objects['Settings']={'Current frame':Blender.Get("curframe"),
                         'Current time':Blender.Get("curtime"),
                         'Start frame':Blender.Get("staframe"),
                         'End frame':Blender.Get("endframe"),
                         'Filename':Blender.Get("filename"),
                         'Version':Blender.Get("version"),
                         'Current Scene':Blender.Scene.getCurrent()}
    print 'settings'
    objects['Armatures']=inspectTopic(Blender.Armature.Get(),recursive=recursive,
                                    useDocString=useDocString)
    print 'armatures'
    objects['Cameras']=inspectTopic(Blender.Camera.Get(),recursive=recursive,
                                    useDocString=useDocString)
    objects['Curves']=inspectTopic(Blender.Curve.Get(),recursive=recursive,
                                    useDocString=useDocString)
    objects['Effects']=inspectTopic(Blender.Effect.Get(),recursive=recursive,
                                    useDocString=useDocString)
    objects['Images']=inspectTopic(Blender.Image.Get(),recursive=recursive,
                                   useDocString=useDocString)
    objects['Ipos']=inspectTopic(Blender.Ipo.Get(),recursive=recursive,
                                 useDocString=useDocString)
    #problem in Blender2.28
##    objects['IpoCurves']=inspectTopic(Blender.IpoCurve.Get(),recursive=recursive,
##                                 useDocString=useDocString)
    objects['Lamps']=inspectTopic(Blender.Lamp.Get(),recursive=recursive,
                                  useDocString=useDocString)
    objects['Materials']=inspectTopic(Blender.Material.Get(),recursive=recursive,
                                      useDocString=useDocString)
    print 'materials'
    objects['Meshes']=BlenderMeshGet
    print 'meshes'
    objects['Metaballs']=inspectTopic(Blender.Metaball.Get(),recursive=recursive,
                                 useDocString=useDocString)
    print 'meta'
    objects['Objects']=inspectTopic(Blender.Object.Get(),recursive=recursive,
                                    useDocString=useDocString)
    print 'objects'
    objects['Scenes']=inspectTopic(Blender.Scene.Get(),recursive=recursive,
                                   useDocString=useDocString)
    print 'scene'
    objects['Texts']=inspectTopic(Blender.Text.Get(),recursive=recursive,
                                  useDocString=useDocString)
    print 'text'
    objects['Types']=inspectTopic(Blender.Types,recursive=recursive,
                                  useDocString=useDocString)
    print 'type'
    objects['Worlds']=inspectTopic(Blender.World.Get(),recursive=recursive,
                                   useDocString=useDocString)
    print 'done'
    return objects

def inspectorBlender(objects={},recursive=10):
    """Launchs a tree dialog which contains all available Python information.
    Maybe also usefull during debugging.
    """
    root=inspect(objects,recursive=recursive,useDocString=0)
    inspector(root,'Blenpy inspector')

#---blenderCrust---------------------------------------------------------------------==
def blenderCrustTabs(tabs):
    """Returns the tabs as a dictionary tabs[label]=(rootObjects,welcomeString,rootLabel)
    Helper function for blenderCrust.
    """
    for tab in tabs.keys():
        if tab=='Blender':
            tabs[tab]=(tabs[tab],'Blender Module','import Blender')
        else:
            if tab=='Meshes':
                label='Blender.Mesh.Get()'
            elif tab=='Settings':
                label='Blender.get(...)'
            else:label='Blender.%s.Get()'%tab[:-1]
            tabs[tab]=(tabs[tab],
                       'This is an inventory of all %s in the Blender drawing.'%tab.lower(),
                       label)
    return tabs

def blenderCrustInventory(data):
    """Return statistics of the Blender Data (how many cameras,objects,...)
    Helper function for blenderCrust
    """
    keys=data.keys()
    keys.sort()
    report=INVENTORY
    report+='\n\n'.join(['\t%s\t%s(s)'%(str(len(data[k])),k[:-1])
                        for k in keys
                        if type(data[k]).__name__=='dict'])
    report+='\n\n'
    return report

def blenderCrust(extraObjects={},blenderImport=1,recursive=7,tab=1):
    """Blender version of PyCrust

    extraObjects:   Add any object to the extraObjects root as a dictionary.
    blenderImport:  Cameras=Blender.Camera.Get(),Objects=Blender.Object.Get(),etc...
    recursive:      Same as blender Import, but execute recursively the get functions
    tab:            Show Cameras,Objects,... in different tabs
    """
    if blenderImport:
        blenderLocals=inspect(recursive=0)
        for key in blenderLocals.keys():extraObjects[key]=blenderLocals[key]
        if recursive>0:tabs=inspect(recursive=recursive)
        else:tabs=blenderLocals
        welcome=blenderCrustInventory(blenderLocals)
    elif tab:
        tabs=inspect(recursive=recursive)
        for key in tabs.keys():extraObjects[key]=tabs[key]
        welcome=blenderCrustInventory(tabs)
    else:
        tabs={}
        welcome=''
    if tabs:inspect(recursive=recursive)
    welcome+=BLENDERCRUST_WELCOME+SHELL_WELCOME
    pyCrust(title='PyCrust for Blender - www.stani.be',
            extraObjects=extraObjects,
            tabs=blenderCrustTabs(tabs),
            welcome=welcome)

def pythonLoad(fileName):
    """Load in Blender text window"""
    fileName=str(fileName)
    fileBase=os.path.basename(fileName)
    prefix=FILE+fileName+'\n'
    try:
        text=Blender.Text.get(fileBase)
        text.clear()
    except:
        text=Blender.Text.New(fileBase)
    file=open(fileName,'r')
    text.write(prefix+file.read())
    file.close()
    return fileName

#---Class pyGui------------------------------------------------------------------------
current=[]
class PythonGui(gui.Gui):
    """Provides an useful gui interface for Python in Blender"""
    #TODO: settings window: settingsDefaults
#---Private--------------------------------------------------------------------
    def __init__(self,pyExt='.py,.pyw'):
        """dirs,editor"""
        global current
        current.append(self)
        gui.Gui.__init__(self,bgColor=(0.3,0.3,0.4,0.8),escape=0)
        #gui.Gui.__init__(self,bgColor=(0.9,0.9,0.9,0.8),escape=0)
        self._y0=0
        self.fileOver=''
        self.currentPath=''

        self.settingsFile=os.path.join(USER_PATH,'settings.py')
        self.workingDir=os.path.dirname(Blender.Get('filename'))

        self.headBg=(0.2,0.2,0.45)
        self.headColor=(1,1,1)
        self.pyColor=[(1,1,1),(0.8,0.8,0.8)]

        #settings
        self.mouseLeftIndex=0
        self.mouseMiddleIndex=1
        self.mouseRightIndex=2
        self.path_depth=5
        self.extensions='.py,.pyw'

        global tools,mouse
        from blenpy.plugins import tools,mouse
        self.settingsLoad()
        self.__initActions__()
        self.__initTools__()

        self.start()

    def __initActions__(self):
        "Retrieve actions from the plugin.mouse module."
        global extEditors
        #internal editors
        intEditors=[e for e in dir(editors) if e[:7]=='editor_']
        self.actionsLabels=['Edit with %s'%e[7:] for e in intEditors]
        unsortedActions=[getattr(editors,e) for e in intEditors]

        self.actionsLabels+=['Send to %s'%e for e in extEditors.keys()]
        unsortedActions+=extEditors.values()

        actions=[self.drawGetLabel(mouse,tool) for tool in dir(mouse) if tool[0]!='_']
        actions=[tool for tool in actions if tool]
        self.actionsLabels+=[tool[0] for tool in actions]
        unsortedActions+=[tool[1] for tool in actions]

        sort={}
        for i in range(len(self.actionsLabels)):
            sort[self.actionsLabels[i]]=i
        self.actionsLabels.sort()
        self.actions=[]
        for i in range(len(self.actionsLabels)):
            self.actions.append(unsortedActions[sort[self.actionsLabels[i]]])

        self.eventMouseLeftSelect(value=self.mouseLeftIndex)
        self.eventMouseMiddleSelect(value=self.mouseMiddleIndex)
        self.eventMouseRightSelect(value=self.mouseRightIndex)

    def __initTools__(self):
        "Retrieve tools from the plugin.mouse module."
        self.tools=[self.drawGetLabel(tools,tool) for tool in dir(tools) if tool[0]!='_']
        self.tools=[tool for tool in self.tools if tool]
        self.tools.sort()
        self.toolsLabels=[tool[0].replace('@','  ') for tool in self.tools]
        self.toolsKeys=[tool[0].split('@')[-1] for tool in self.tools]
        self.tools=[tool[1] for tool in self.tools]
        self.eventLaunchSelect(value=self.launchIndex)

    def _mouseY(self,val):
        """pdate mouse y coordinate & statusbar for fileName.(custom)"""
        n=len(self.currentPath)
        fileOver=os.path.dirname(self.fileY())[n:n+21]
        self.mouseY=val
        if fileOver!=self.fileOver:
            Blender.Window.DrawProgressBar(0.0,fileOver)
            self.fileOver=fileOver

#---Directories & files--------------------------------------------------------
    def dirAdd(self):
        """Adds the directory in the edit field to self.paths"""
        dirEdit=self.value['dirEdit'].val
        if dirEdit not in self.paths:
            if os.path.exists(dirEdit):
                self.paths.append(dirEdit)
                self.value['dirSelected'].val=len(self.paths)
            elif not self.drawing:self.value['dirEdit'].val='invalid path!'
        elif not self.drawing:self.value['dirEdit'].val='path already in menu!'
        self.redraw()
        self.drawing=0

    def dirAsk(self):
        """Pops up a dialog to ask for a directory."""
        dir=self.value['dirEdit'].val.strip()
        if dir in ['','...']:dir=self.workingDir
        #dir=dirDialog(dir,'Choose Python script directory...')
        dir=askdirectory(dir,title='Choose Python script directory...')
        if dir:
            self.value['dirEdit'].val=str(dir)
            self.dirAdd()

    def dirRemove(self):
        """Removes the directory in the edit field to self.paths"""
        selected=self.value['dirSelected'].val
        if selected>2:
            self.paths.remove(self.paths[selected-1])
            self.value['dirSelected'].val=2
            self.redraw()


    def fileY(self):
        """Retrieves which file is under the cursor by the y coordinate."""
        if self.fileList:
            path=self.paths[self.value['dirSelected'].val-1]
            if path==WORKING_DIR:path=self.workingDir
            b=(self.mouseY-self._y0)/(self.control_height)-1
            if -1<b<len(self.fileList):
                return os.path.join(path,self.fileList[b])
            else:return''
        else:return''

    def files(self,path=0,recursive=-1,sort=1):
        """Returns a list of python files of the selected directory."""
        if recursive==-1:recursive=self.path_depth
        if not path:
            path=self.value['dirSelected'].val
            if path<2:
                self.fileList=[]
                return []
            path=self.paths[path-1]
            if path==WORKING_DIR:
                path=self.workingDir
        try:
            l=os.listdir(path)
        except:
            return []
        fileList=[os.path.join(path,x) for x in l
                  if os.path.splitext(x)[-1] in self.extensions.split(',')]
        if recursive:
            pathList=[os.path.join(path,x) for x in l
                      if os.path.isdir(os.path.join(path,x))]
            for subPath in pathList:
                fileList+=self.files(subPath,recursive-1,sort=0)
        if sort:
            self.currentPath=path
            fileDict={}
            for file in fileList:fileDict[os.path.basename(file).lower()]=file
            fileKeys=fileDict.keys()
            fileKeys.sort()
            fileKeys.reverse()
            fileList=[fileDict[file] for file in fileKeys]
            self.fileList=fileList
        return fileList

#---Settings-------------------------------------------------------------------
    def settingsDefaults(self,redraw=1):
        """Restore default settings from file."""
        for key in DEFAULT_SETTINGS.keys():
            if key!='paths':
                self.__dict__[key]=DEFAULT_SETTINGS[key]
                if redraw and key in self.value.keys():
                    self.value[key].val=DEFAULT_SETTINGS[key]
        if redraw:self.redraw()

    def settingsLoad(self):
        """Restores menu settings from file."""
        self.paths=['Select here...',WORKING_DIR]
        try:
            settingsFile=open(self.settingsFile,'r')
            settings=eval(settingsFile.read())
            settingsFile.close()
            settingsKeys=settings.keys()
            for key in DEFAULT_SETTINGS.keys():
                if key in settingsKeys:
                    if key=='paths':self.paths+=settings[key]
                    else:self.__dict__[key]=settings[key]
                else:
                    if key=='paths':self.paths+=DEFAULT_SETTINGS[key]
                    else:self.__dict__[key]=DEFAULT_SETTINGS[key]
        except:
            self.settingsDefaults(redraw=0)
            print 'Warning: unable to load settings from...\n',self.settingsFile

    def settingsSave(self):
        """Saves menu settings to file."""
        try:
            settingsFile=open(self.settingsFile,'w')
            settings={}
            for key in DEFAULT_SETTINGS.keys():
                if key=='paths':settings[key]=self.__dict__[key][2:]
                else:settings[key]=self.__dict__[key]
            settingsFile.write(pprint.pformat(settings))
            settingsFile.close()
        except:
            print 'Warning: unable to save settings to...\n%s'%self.settingsFile

    def exit(self,forced=0):
        """Exists the gui"""
        self.settingsSave()
        Blender.Draw.Exit()
        if not forced:current.remove(self)

#---Reload/Save All------------------------------------------------------------
    def eventLaunch(self,keyDown=0):
        """Launches the selected tool."""
        if not keyDown:self.launch()

    def eventLaunchSelect(self,keyDown=0,value=-1):
        """Called when the user changes the menu of the tool to launch."""
        if value==-1 or self.launchIndex>=len(self.tools):
            self.launchIndex=self.value['launchIndex'].val-1
        else:self.launchIndex=value
        self.launch=self.tools[self.launchIndex]
        self.redraw()

    def eventMouseLeft(self,keyDown=0):
        """Launches the action by a left click of the mouse."""
        fileName=self.fileY()
        if fileName:self.mouseLeft(fileName)

    def eventMouseLeftSelect(self,keyDown=0,value=-1):
        """Called when the user changes the menu for the left mouse button."""
        if value==-1:
            self.mouseLeftIndex=self.value['mouseLeftIndex'].val-1
        elif self.mouseLeftIndex>=len(self.actions):
            self.mouseLeftIndex=1
        else:self.mouseLeftIndex=value
        self.mouseLeft=self.actions[self.mouseLeftIndex]

    def eventMouseMiddle(self,keyDown=0):
        """Launches the action by a middle click of the mouse."""
        fileName=self.fileY()
        if fileName:self.mouseMiddle(fileName)

    def eventMouseMiddleSelect(self,keyDown=0,value=-1):
        """Called when the user changes the menu for the middle mouse button."""
        if value==-1:
            self.mouseMiddleIndex=self.value['mouseMiddleIndex'].val-1
        elif self.mouseMiddleIndex>=len(self.actions):
            self.mouseMiddleIndex=1
        else:self.mouseMiddleIndex=value
        self.mouseMiddle=self.actions[self.mouseMiddleIndex]

    def eventMouseRight(self,keyDown=0):
        """Launches the action by a right click of the mouse."""
        fileName=self.fileY()
        if fileName:self.mouseRight(fileName)

    def eventMouseRightSelect(self,keyDown=0,value=-1):
        """Called when the user changes the menu for the right mouse button."""
        if value==-1:
            self.mouseRightIndex=self.value['mouseRightIndex'].val-1
        elif self.mouseRightIndex>=len(self.actions):
            self.mouseRightIndex=1
        else:self.mouseRightIndex=value
        self.mouseRight=self.actions[self.mouseRightIndex]

    def eventReloadAll(self,keyDown=0):
        """Reloads all previous loaded python files."""
        if not keyDown:
            reloaded=[]
            for text in Blender.Text.Get():
                text=Blender.Text.get(text.name).asLines()
                if text[0][:2]==FILE:
                    reloaded.append(self.pythonLoad(fileName=text[0][2:]))
            if reloaded:
                print "Following files are reloaded:"
                for x in reloaded:print " ",x
            else:print "Unable to reload any file"
            Blender.Window.QRedrawAll()

    def eventSaveAll(self,keyDown=0):
        """Saves all previous loaded python files."""
        if not keyDown:
            saved=[]
            for text in Blender.Text.Get():
                text=Blender.Text.get(text.name).asLines()
                if text[0][:2]==FILE:
                    fileName=text[0][2:]
                    file=open(fileName,'w')
                    file.write('\n'.join(text[1:]))
                    file.close()
                    saved.append(fileName)
            if saved:
                print "Following files are saved:"
                for x in saved:print " ",x
            else:print "Unable to save any file"

    def eventSelect(self):
        """Selects the directory of which the Python files will be displayed
        as buttons. Redraw will look for the files."""
        self._y0=self.mouseY-(self.control_height/2)
        self.redraw()

#---General functions----------------------------------------------------------
    def draw(self):
        """Draws the Python script gui."""
        #self.rectangle(0,0,230,1500,color=(0.3,0.3,0.4))
        self.drawCaption()
        self.drawBase()
        self._y+=SPACER
        self.files()
        if self.fileList:self.drawFiles()
        else:self.drawSettings()
        self.drawSetKeys()


    def drawBase(self):
        """Draws the base menu which is always displayed"""
        self.button("Revert All",action=self.eventReloadAll,x=0,dy=SPACER,
                    width=70,tooltip='Revert all from saved files\tR')
        self.button("Save All",action=self.eventSaveAll,dx=SPACER,
                    tooltip='Save all files\tS')
        self.button("Exit",action=self.exit,dx=SPACER,
                    tooltip='Exit\tEsc')

        self.button("launch",action=self.eventLaunch,x=0,dy=SPACER,width=45,
                    tooltip="Launches the tool\tENTER")
        self.menu(self.toolsLabels,action=self.eventLaunchSelect,id='launchIndex',initial=self.launchIndex+1,dx=0,
                  width=175,tooltip='Select a tool to launch')

        self.button("b",action=self.dirAsk,x=0,dy=SPACER,width=15,
                    tooltip="Browse directory(requires wxpython)\tB")
        self.button("+",action=self.dirAdd,dx=0,width=15,
                    tooltip="Add directory\tA")
        self.button("-",action=self.dirRemove,dx=0,width=15,
                    tooltip="Remove directory\tE")
        self.string(id='dirEdit',initial='...',dx=0,width=175,
                    tooltip='Type here new directory to add to menu.')

        self.menu(self.paths,action=self.eventSelect,id='dirSelected',initial=1,x=0,
                  dy=SPACER,width=220,tooltip='Select directory from menu.')

    def drawGetLabel(self,module,tool):
        obj=getattr(module,tool)
        if type(obj)==types.FunctionType:
            doc=eval('obj.__doc__')
            if doc:doc=doc.split('\n')[0]
            else: doc=str(obj.__name__)
            return (doc,obj)
        else:return None

    def drawCaption(self,steps=100):
        """Draws a caption down with a gradient."""
        steps=float(steps)
        dr=self.bgColor[0]/steps
        dg=self.bgColor[0]/steps
        db=self.bgColor[0]/steps
        for step in range(steps):
            self.rectangle(x0=step-1,y0=0,x1=step,y1=self.control_height,
                           color=(step*dr,step*dg,step*db))
        self.text("%s v%s    (c)www.stani.be 2003"%\
                  (INFO['title'],INFO['version']),
                  color=(1,1,1))

    def drawFilesMouse(self,x):
        """Returns the mouse action for the table caption."""
        split=x.split(' ')
        if split[0].lower() in ['edit','send']:return split[-1]
        else:return split[0]

    def drawFiles(self):
        """Draws at table of files."""
        self.rectangle(x0=self.originX,y0=self._y+self.control_height-1,
                       x1=self._x+self.control_width,
                       y1=self._y+(len(self.fileList)+2)*self.control_height+3,
                       color=(0,0,0))#black line
        even=0
        title=' L:%s | M:%s | R:%s#@color=self.headColor#@bgColor=self.headBg'%\
               (self.drawFilesMouse(self.actionsLabels[self.mouseLeftIndex]),
                self.drawFilesMouse(self.actionsLabels[self.mouseMiddleIndex]),
                self.drawFilesMouse(self.actionsLabels[self.mouseRightIndex]))
        for file in self.fileList+[title]:
            even=not even
            self.text(os.path.basename(file),x=3,dy=0,width=220,
                      bgOffset=(-2,0,-4,2),color=(0.3,0.3,0.3),
                      bgColor=self.pyColor[even])

##    def drawInstructions(self):
##        """Obsolete"""
##        self.rectangle(x0=self.originX,y0=self._y+self.control_height-1,
##                       x1=self._x+self.control_width,
##                       y1=self._y+(len(INSTRUCTIONS)+1)*self.control_height+3,
##                       color=(1,1,1),border=-1)
##        self.color()
##        for line in INSTRUCTIONS:
##            self.text(line,x=3,dy=0,bgOffset=(-2,0,-4,2),color=TEXTCOLOR)
##
    def drawSetKeys(self):
        """Set key events."""
        for key in range(len(self.toolsKeys)):
            try:
                drawKey=eval('Blender.Draw.%sKEY'%self.toolsKeys[key])
                self.key(key=drawKey,action=self.tools[key])
            except:
                pass
        self.key(Blender.Draw.AKEY,self.dirAdd)
        self.key(Blender.Draw.BKEY,self.dirAsk)
        self.key(Blender.Draw.EKEY,self.dirRemove)
        self.key(Blender.Draw.ESCKEY,self.exit)
        self.key(Blender.Draw.LEFTMOUSE,self.eventMouseLeft)
        self.key(Blender.Draw.MIDDLEMOUSE,self.eventMouseMiddle)
        self.key(Blender.Draw.RIGHTMOUSE,self.eventMouseRight)
        self.key(Blender.Draw.RKEY,self.eventReloadAll)
        self.key(Blender.Draw.RETKEY,self.eventLaunch)
        self.key(Blender.Draw.SKEY,self.eventSaveAll)

    def drawSettings(self):
        #external editors,internal editors,helpfile,mouse buttons

        #drawing
        #editor
        if self.launch.__doc__:doc=self.launch.__doc__
        else:doc=''
        doc=[line.strip() for line in doc.split("\n")[1:] if line.strip()]
        doc.reverse()
        if doc:n=7+len(doc)
        else:n=6
        self.rectangle(x0=self.originX,y0=self._y+self.control_height-1,
                       x1=self._x+self.control_width,
                       y1=self._y+(n+1)*self.control_height+(n+2)*SPACER+1,
                       color=(1,1,1),border=-1)
        self._y+=SPACER
        self.button("Default",action=self.settingsDefaults,x=60,dy=SPACER,width=70,
                    tooltip="Restore default settings.")
        self.button("Save",action=self.settingsSave,dx=SPACER,width=75,
                    tooltip="Save settings.")
##        self.text("#@color=self.headColor#@bgColor=self.headBg",
##                  x=10,width=200,dy=SPACER,color=(1,1,1),
##                  bgOffset=(-9,0,9,0))

        #mouse
        self._y+=SPACER
        self.text("right:",x=20,dy=SPACER,width=40,color=TEXTCOLOR)
        self.menu(self.actionsLabels,action=self.eventMouseRightSelect,
                  id='mouseRightIndex',initial=self.mouseRightIndex+1,dx=0,width=150,
                  tooltip='Select a mouse action.')
        self.text("middle:",x=20,dy=SPACER,width=40,color=TEXTCOLOR)
        self.menu(self.actionsLabels,action=self.eventMouseMiddleSelect,
                  id='mouseMiddleIndex',initial=self.mouseMiddleIndex+1,dx=0,width=150,
                  tooltip='Select a mouse action.')
        self.text("left:",x=20,dy=SPACER,width=40,color=TEXTCOLOR)
        self.menu(self.actionsLabels,action=self.eventMouseLeftSelect,
                  id='mouseLeftIndex',initial=self.mouseLeftIndex+1,dx=0,
                  width=150,tooltip='Select a mouse action.')
        self.text("Mouse actions:",color=TEXTCOLOR,
                  x=10,width=200,dy=SPACER,
                  bgOffset=(-9,0,9,0))
        self.text("Settings#@color=self.headColor#@bgColor=self.headBg",
                  x=10,width=200,dy=SPACER,color=(1,1,1),
                  bgOffset=(-9,0,9,0))
        #tooltip
        if doc:
            for line in doc:self.text(line,x=10,dy=SPACER,width=200,color=TEXTCOLOR)
            self.text("%s#@color=self.headColor#@bgColor=self.headBg"%self.toolsLabels[self.launchIndex],
                      x=10,width=200,dy=SPACER,color=(1,1,1),
                      bgOffset=(-9,0,9,0))


#---Main---------------------------------------------------------------------==
if __name__=="__main__":PythonGui()