#(c)www.stani.be (read __doc__ for more information)
import sm
INFO=sm.INFO.copy()

INFO['description']=\
"""Adaption of tkinkter routines belonging to Tkinter,tkFileDialog,ObjectBrowser
and PyShell"""

__doc__=INFO['doc']%INFO
#_______________________________________________________________________________

#===Import Modules=============================================================
import os,sys

#===tkFileDialog===============================================================
def askopenfilename(title='www.stani.be',defaultextension='',initialdir='',filetypes=[],**options):
    "Ask for a filename to open"
    try:
        import tkFileDialog
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
    return _showDialog(tkFileDialog.askopenfilename,title=title,
        defaultextension=defaultextension,initialdir=initialdir,
        filetypes=filetypes)

def asksaveasfilename(title='www.stani.be',defaultextension='',initialdir='',initialfile='',filetypes=[],**options):
    "Ask for a filename to save as"
    try:
        import tkFileDialog
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
    return _showDialog(tkFileDialog.asksaveasfilename,title=title,
        defaultextension=defaultextension,initialdir=initialdir,
        initialfile=initialfile,filetypes=filetypes)

def askdirectory (initialdir='', title='www.stani.be',mustexist=1,**options):
    "Ask for a directory, and return the file name"
    try:
        import tkFileDialog
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
    return _showDialog(tkFileDialog.askdirectory,title=title,
        initialdir=initialdir,mustexist=mustexist)

def _showDialog(f,**options):
    try:
        import Tkinter
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
    root = Tkinter.Tk()
    print 'hello2'
    dialog=_Callback(f,parent=root,**options)

    root.after_idle(dialog)

    root.mainloop()
    root.destroy()
    return root.result

class _Callback:
    def __init__(self,action,**options):
        self.action=action
        self.options=options
        self.parent=options['parent']
    def __call__(self,*args,**keyw):
        self.parent.result=self.action(**self.options)
        self.parent.quit()

#===ObjectBrowser: tkInspect===================================================
def inspector(object,description='Browse...'):
    """Launch a Tkinter window for interactive object browsing.
    Useful for inspecting during debugging, instead of a print statement.
    """
    try:
        import Tkinter
        import idle.ObjectBrowser as ObjectBrowser
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    root = Tkinter.Tk()
    root.configure(bd=0, bg="yellow")
    root.focus_set()
    sc = ObjectBrowser.ScrolledCanvas(root, bg="white", highlightthickness=0, takefocus=1)
    sc.frame.pack(expand=1, fill="both")
    item = ObjectBrowser.make_objecttreeitem(description, object)
    node = ObjectBrowser.TreeNode(sc.canvas, None, item)
    node.update()
    root.mainloop()

#===PyShell/idle===============================================================

def debugger(filename='',title='Python Shell [debug mode]',fork=1):
    """Start idle debugger for this file(string)"""
    idle(filename=filename,title=title,debug=1)

def editor(filename='',title='Python Shell',fork=1):
    """Start idle editor for this file(string)"""
    idle(filename=filename,title=title,edit=1)

def idle(filename='',shell=1,title='',edit=0,debug=0):#custom from PyShell.main
    """Launch the Python Shell.
      opts is a list of tuples (o,a), with o:
        -c command  run this command
        -d          enable debugger
        -e          edit mode; arguments are files to be edited
        -s          run $IDLESTARTUP or $PYTHONSTARTUP before anything else
        -t title    set title of shell window"""

    try:
        import Tkinter
        import sm_idle.PyShell as PyShell
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return

    if title:PyShell.PyShell.shell_title = title
    for i in range(len(sys.path)):
        sys.path[i] = os.path.abspath(sys.path[i])

    if edit:dir=os.path.dirname(filename)
    else:dir=os.curdir
    dir = os.path.abspath(dir)
    if not dir in sys.path:
        sys.path.insert(0, dir)

    PyShell.root = Tkinter.Tk(className="Idle")
    PyShell.fixwordbreaks(PyShell.root)
    PyShell.root.withdraw()
    PyShell.flist = PyShell.PyShellFileList(PyShell.root)

    if edit:editor=PyShell.flist.open(filename)
    else:PyShell.sys.argv = [""]

    if shell or debug:
        shell = PyShell.PyShell(PyShell.flist)
        interp = shell.interp
        PyShell.flist.pyshell = shell
        if debug:shell.open_debugger()
        shell.begin()

    #CUSTOM: update Blender screen
    if shell:shell.top.bind("<Configure>", BlenderRedraw)
    if edit:editor.top.bind("<Configure>", BlenderRedraw)

    PyShell.root.mainloop()
    PyShell.root.destroy()

try:
    import Blender
except:
    Blender=None

def BlenderRedraw(event):
    if Blender:Blender.Redraw()

def idleFork(filename='',title='Python Shell',fork=1):
    """Start idleFork editor for this file(string)"""
    try:
        import Tkinter
        from idleforklib import PyShell as PyShellFork
    except ImportError,exception:
        print '%s:\n%s\n'%(exception,ImportError.__doc__)
        return
    PyShellFork.use_subprocess=0
    PyShellFork.sys.argv=[filename]
    PyShellFork.root = Tkinter.Tk(className="Idle")
    PyShellFork.fixwordbreaks(PyShellFork.root)
    PyShellFork.root.withdraw()
    PyShellFork.flist = PyShellFork.PyShellFileList(PyShellFork.root)
    PyShellFork.flist.open(filename)
    PyShellFork.root.mainloop()
    PyShellFork.root.destroy()



#===Main=======================================================================
if __name__=='__main__':
    idle()
    #editor(filename='hello.py')