#(c)www.stani.be
import spe.info
INFO=spe.info.copy()

INFO['description']=\
"""Drag & Drop implementation for spe."""

__doc__=INFO['doc']%INFO
#---import modules--------------------------------------------------------------
import os
from wxPython.wx import wx

#---drag & drop classes---------------------------------------------------------
class FileParentOpen(wx.wxFileDropTarget):
    """Opens a file when dropped on parent frame."""
    def __init__(self,open):
        wx.wxFileDropTarget.__init__(self)
        self.open=open
    def OnDropFiles(self,x,y,fileNames):
        fileNames=[script for script in fileNames
            if os.path.splitext(script)[-1].lower() in ['.py','.pyw']]
        if fileNames:
            self.open(fileNames)
            return 1
        else:return 0

class FileShellRun(wx.wxFileDropTarget):
    """Runs a file when dropped on shell."""
    def __init__(self,run):
        wx.wxFileDropTarget.__init__(self)
        self.run=run
    def OnDropFiles(self,x,y,fileNames):
        fileNames=[script for script in fileNames
            if os.path.splitext(script)[-1].lower() in ['.py','.pyw']]
        if fileNames:
            for fileName in fileNames:
                self.run(fileName)
            return 1
        else:return 0

class FileRecentAdd(wx.wxFileDropTarget):
    """Adds a file to recent files when dropped on recent tab."""
    def __init__(self,add):
        wx.wxFileDropTarget.__init__(self)
        self.add=add
    def OnDropFiles(self,x,y,fileNames):
        fileNames=[script for script in fileNames
            if os.path.splitext(script)[-1].lower() in ['.py','.pyw']]
        if fileNames:
            self.add(fileNames)
            return 1
        else:return 0

class FileBrowserAdd(wx.wxFileDropTarget):
    """Adds a file to browser when dropped on browser tab."""
    def __init__(self,add):
        wx.wxFileDropTarget.__init__(self)
        self.add=add
    def OnDropFiles(self,x,y,fileNames):
        fileNames=[dir for dir in fileNames if os.path.isdir(dir)]
        if fileNames:
            self.add(fileNames)
            return 1
        else: return 0